# Readme

## Overview

BiaWeb2 is a static site generator written in C++, that takes a directory tree 
of documents (in Markdown format - more on that later) and outputs a website 
with the same tree structure, based on a set of templates. 

BiaWeb2 supports infinite nesting level of source sub-directories, with 
each directory representing a "category". Thus, a website can have (say)
a structure like
    + Home
      + ----- Blog
      + ------+------ Travel
      + ------+------ History
      + ------+------ Personal
      + ------+------ Technology      
      + ----- Creative
      + ------+------ Reviews
      + ------+------ +------- Books
      + ------+-------+--------+-------- Fiction
      + ------+-------+--------+-------- Non-fiction
      + ----- Miscellaneous

Thus the entire structure of the website is represented by the filesystem
hierarchy of directories (which I think is an intuitive way of organizing
categories).

`biaweb2` is a command-line program that performs the entire website 
generation in one step. The usage is:

    biaweb2 -i <inputdir> -o <outputdir> -t <templatedir> [-q]

Where `<inputdir>` is the input directory, `<outputdir>` is the destination
directory and `<templatedir>` is the location of the template files. The
`templates` directory in the __biaweb2__ source package provides a default
template that can be further customized to suit your needs. The main philosophy
of BiaWeb2 is to be as configuration-free as possible and hence most of the 
customization for a specific website is within the templates themselves. The
option `-q` is quiet-mode, to suppress the messages. 